// Code which handles the image object

var pgw_map_update_lock=false;


function pgwUpdateMap() {
  var text_lat=document.getElementById("lat");
  text_lat.value=pgwGetCenterLat();
  var text_long=document.getElementById("long");
  text_long.value=pgwGetCenterLong();
  if (!pgwIsMapLocked()) {
    pgwLockMap();
    var map=document.getElementById("map");
    map_src=encodeURI(pgw_cgi_bin
		      +"?map_width_px="+pgw_map_width_px
		      +"&map_height_px="+pgw_map_height_px
		      +"&long_min="+pgw_long_min
		      +"&long_max="+pgw_long_max
		      +"&lat_min="+pgw_lat_min
		      +"&lat_max="+pgw_lat_max);
    map.src=map_src;
    setTimeout("pgwUnlockMap();",1000);
  } else {
    setTimeout("pgwUpdateMap();",1000);
  }
}

function pgwLockMap() {
  pgw_map_update_lock=true;
}

function pgwUnlockMap() {
  pgw_map_update_lock=false;
}

function pgwIsMapLocked() {
  return pgw_map_update_lock;
}

function pgwGetCenterLat(y) {
  y=(pgw_lat_min+pgw_lat_max)/2;
  y=Math.round(y*1000000)/1000000;

  return y;
}

function pgwGetCenterLong(x) {
  x=(pgw_long_min+pgw_long_max)/2;
  x=Math.round(x*1000000)/1000000;

  return x;
}

function pgwGetDiffLat() {
  return pgw_lat_max-pgw_lat_min;
}

function pgwGetDiffLong() {
  return pgw_long_max-pgw_long_min;
}

// fix the width/height ratio
function pgwFixRatio() {
  // Todo: check that width/height is coherent
}

// move North
function pgwMoveUpOf(d_lat) {
  if (pgw_lat_max+d_lat>pgw_absolute_lat_max) {
    d_lat=pgw_absolute_lat_max-pgw_lat_max;
  }
  pgw_lat_max+=d_lat;
  pgw_lat_min+=d_lat;
  pgwFixRatio();
  pgwUpdateMap();
  pgw_google_iframe.pgwSynchronizePos();
}

// move East
function pgwMoveRightOf(d_long) {
  if (pgw_long_max+d_long>pgw_absolute_long_max) {
    d_long=pgw_absolute_long_max-pgw_long_max;
  }
  pgw_long_max+=d_long;
  pgw_long_min+=d_long;
  pgwFixRatio();
  pgwUpdateMap();
  pgw_google_iframe.pgwSynchronizePos();
}

// move South
function pgwMoveDownOf(d_lat) {
  if (pgw_lat_min-d_lat<pgw_absolute_lat_min) {
    d_lat=pgw_lat_min-pgw_absolute_lat_min;
  }
  pgw_lat_max-=d_lat;
  pgw_lat_min-=d_lat;
  pgwFixRatio();
  pgwUpdateMap();
  pgw_google_iframe.pgwSynchronizePos();
}

// move West
function pgwMoveLeftOf(d_long) {
  if (pgw_long_min-d_long<pgw_absolute_long_min) {
    d_long=pgw_long_min-pgw_absolute_long_min;
  }
  pgw_long_max-=d_long;
  pgw_long_min-=d_long;
  pgwFixRatio();
  pgwUpdateMap();
  pgw_google_iframe.pgwSynchronizePos();
}

function pgwMoveUp() {
  var d_lat=pgwGetDiffLat()*pgw_move_factor;
  pgwMoveUpOf(d_lat);
}

function pgwMoveRight() {
  var d_long=pgwGetDiffLong()*pgw_move_factor;
  pgwMoveRightOf(d_long);
}

function pgwMoveDown() {
  var d_lat=pgwGetDiffLat()*pgw_move_factor;
  pgwMoveDownOf(d_lat);
}

function pgwMoveLeft() {
  var d_long=pgwGetDiffLong()*pgw_move_factor;
  pgwMoveLeftOf(d_long);
}

function pgwZoom(factor) {
  var center_long=pgwGetCenterLong();
  var center_lat=pgwGetCenterLat();
  var d_long=(pgw_long_max-pgw_long_min)/factor;
  var d_lat=(pgw_lat_max-pgw_lat_min)/factor;

  pgw_long_min=center_long-d_long/2;
  pgw_long_max=center_long+d_long/2;
  pgw_lat_min=center_lat-d_lat/2;
  pgw_lat_max=center_lat+d_lat/2;

  // Todo: check for zoom limits (in/out)

  pgwFixRatio();
  pgwUpdateMap();
}

function pgwZoomIn() {
  pgwZoom(pgw_zoom_factor);
}

function pgwZoomOut() {
  pgwZoom(1./pgw_zoom_factor);
}

function pgwSetLatFromTextCoord(new_lat) {
  var d_lat=parseFloat(new_lat)-pgwGetCenterLat();
  if (d_lat>0) {
    pgwMoveUpOf(d_lat);
  } else if (d_lat<0) {
    pgwMoveDownOf(-d_lat);
  }
}

function pgwSetLongFromTextCoord(new_long) {
  var d_long=parseFloat(new_long)-pgwGetCenterLong();
  if (d_long>0) {
    pgwMoveRightOf(d_long);
  } else if (d_long<0) {
    pgwMoveLeftOf(-d_long);
  }
}

function pgwUpdatePos(x,y) {
  var d_lat=y-pgwGetCenterLat();
  var d_long=x-pgwGetCenterLong();

  if (d_lat!=0 || d_long!=0) {
    pgw_lat_min+=d_lat;  
    pgw_lat_max+=d_lat;  
    pgw_long_min+=d_long;  
    pgw_long_max+=d_long;  

    pgwFixRatio();
    pgwUpdateMap();
  }
}

function pgwHandleClick(x,y) {
  /*
   * Test here in which mode we are (edit, select, route, point, track...)
   */
  switch (pgwGetClickMode()) {
  case 0: // move on map
    break;
  case 1: // select nearest
    break;
  case 2: // select and update
    break;
  case 3: // insert before
    break;
  case 4: // insert after
    if (pgw_selected_route_id>0) {
      pgwAddRoutePoint("TEST",x,y,0); 
      break; 
    }
  }
}



